/* -*- Mode: Javascript; tab-width: 2; c-basic-offset: 2; -*-
 * 
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s): 
 *
 *  Doug Turner   <dougt@acm.org> 
 *  Pete Collins  <petejc@mozdev.org> 
 */

const G_VER             = "0.1.375";
const G_MSG             = "JSLIB v"+G_VER;
const G_NAME            = "JSLIB";
const G_CHROME          = "Chrome";
const G_USER            = "Current User";
const G_RT              = "jslib";
const G_CONTENT         = "/";

const G_CHROME_DIR      = getFolder(G_CHROME, "");
const G_USER_CHROME_DIR = getFolder(G_USER, "chrome");

const COMNT_1           = "INSTALL FOR JSLIB AS ARCHIVE . . . \n\nInstall: ";
const COMNT_2           = "JSLIB Archive";
const KILO_BYTES        = 200; // 200K

const CONFIRM_MSG       =   "jslib has failed to install globally on your system. " 
                          + "This is most likely due to you not having the required " 
                          + "system permissions to do so.\n\n" 
                          + "Would you like to install jslib in your " 
                          + "Mozilla user directory instead?\n\n"
                          + "This means that only the current profile "
                          + "will be able to use jsib.\n\n"
                          + "If you wish to have a global install of jslib, you can cancel "
                          + "the install here and login as system administrator and retry "
                          + "the install from there. ";

var rv                 = initInstall(G_MSG, G_NAME, G_VER); 

logComment(COMNT_1 + rv);

if (verifyDiskSpace(getFolder("Program"), KILO_BYTES)) 
{
  rv = addDirectory(COMNT_2, "chrome", G_CHROME_DIR, "");

  // XXX Add command line "-jslib" handler --pete
  rv = addDirectory("Commandline Handler", "components", 
                    getFolder("Components"), "" );

  logComment("add jslib components: "+rv);

  if (rv == 0) {
    // register chrome in global chrome
    rv = registerChrome(PACKAGE|CONTENT|DELAYED_CHROME,
                        getFolder(G_CHROME_DIR, G_RT), "");
    logComment("register jslib chrome: "+rv);
    rv = registerChrome(CONTENT|DELAYED_CHROME,
                        getFolder(G_CHROME_DIR, "jsliblive"), "");
    logComment("register jsliblive chrome: "+rv);
  } else {
    // cancel previous install attempt
    cancelInstall(rv);
    if (confirm(CONFIRM_MSG)) {
      // reinitialize the install
      rv = initInstall(G_MSG, G_NAME, G_VER);
      rv = addDirectory("", G_RT,  getFolder(G_USER_CHROME_DIR, G_RT),  "");
      if (rv == 0) {
        // register chrome in user home 
        rv = registerChrome(PACKAGE|CONTENT|PROFILE_CHROME, 
                            getFolder(G_USER_CHROME_DIR, G_RT), "");
        rv = registerChrome(CONTENT|DELAYED_CHROME, getFolder(G_USER_CHROME_DIR, "jsliblive"), G_CONTENT);
      }
    }
  }
}

rv = getLastError();

if (rv == SUCCESS)
  performInstall(); 
else
  cancelInstall(rv);


// this function verifies disk space in kilobytes
function verifyDiskSpace(aDirPath, aSpaceRequired)
{
  var spaceAvailable;
  var rv = true;
                                                                                                    
  // Get the available disk space on the given path
  spaceAvailable = fileGetDiskSpaceAvailable(aDirPath);
                                                                                                    
  // Convert the available disk space into kilobytes
  spaceAvailable = parseInt(spaceAvailable / 1024);
                                                                                                    
  // do the verification
  if (spaceAvailable < aSpaceRequired) {
    logComment("Insufficient disk space: " + aDirPath);
    logComment("  required : " + spaceRequired + " K");
    logComment("  available: " + spaceAvailable + " K");
    rv = false;
  }
                                                                                                    
  return rv;
}

